<template>
  <div>
    <div class="fullHistory_body commissions_referrals">
      <div class="table_head">
        <div class="table-tr flex flex-middle">
          <div class="table-th">#</div>
          <div class="table-th">{{$t('common.wallet')}}</div>
          <div class="table-th">{{$t('common.bets')}}</div>
          <div class="table-th">{{$t('common.commissions')}}</div>
          <div class="table-th"></div>
        </div>
      </div>
      <div class="table">
        <div
          class="table_body"
          ref="container">
          <div
            class="table_body-inner"
            v-for="(item, key) in data"
            :key="key"
          >
            <div
              class="table-tr flex flex-middle lastWin">
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-white">
                    {{key+1}}
                  </div>
                </div>
              </div>
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-white">
                    {{item.username}}
                  </div>
                </div>
              </div>
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-white">
                    {{item.bet}} EOS
                  </div>
                </div>
              </div>
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-green">
                    {{item.amount}} EOS
                  </div>
                </div>
              </div>
              <div class="table-td">
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <LoadingLabel v-show="loading"></LoadingLabel>
  </div>
</template>

<script>
  import {getScrollPercent} from "~/components/utils";
  import debounce from 'lodash.debounce';
  import LoadingLabel from '~/components/UI/LoadingLabel';

  export default {
    name: "body_referrals",
    data() {
      return {
        limit: 20,
        offset: 0,
        page: 1,
        loading: false,
        lastScrollY: 0,
        gq: () => {
        },
      }
    },
    components: {
      LoadingLabel
    },
    computed: {
      data() {
        return this.$store.state.players.referrals;
      }
    },
    methods: {
      async getData() {
        this.loading = true;
        await this.$store.dispatch('players/fetchReferrals', {
          offset: this.limit * (this.page - 1),
          limit: this.limit
        });
        this.loading = false;
      }
    },
    mounted() {
      this.gq = debounce(this.getData, 800);
      this.getData();

      this.$onWrapperScroll.flush();
      this.$onWrapperScroll.onScroll((e) => {
        if (getScrollPercent(this.$onWrapperScroll.container) > 80 && e.target.scrollTop > this.lastScrollY && !this.loading) {
          this.lastScrollY = e.target.scrollTop;
          this.loading = true;
          this.page += 1;
          this.$nextTick(_ => {
            this.gq();
          });
        }
      });

      /*this.$refs['container'].onscroll = (e) => {
        if (getScrollPercent(this.$refs['container']) > 80 && !this.loading) {
          this.loading = true;
          this.page += 1;
          this.$nextTick(_ => {
            this.gq();
          });
        }
      }*/
    }
  }
</script>
